source("NeighborhoodDataWD.R");
source("Net_Import.R");
source("NetCmbn.R");
source("Para_SIS.R");
source("Para_SAIS_2layer.R");
source("Post_Population.R");
source("Post_NodesState.R");
source("GEMF_SIM.R");
source("GEMF_SIM_Prob.R");
source("NetGen_Geo.R");
source("NetGen_ER.R");
source("Net_Import2.R");

#Importing a directed and weighted Net from a file
  #File="edgewd.txt"
  #N=379;
  #Net=Net_Import(File,N); 
  
   File="admat.txt"
   dum=Net_Import2(File,edgelist=FALSE,adjacencymatrix=TRUE);
   Net=dum[[1]];
   N=dum[[2]];
   
   
#setting up the SIS epidemic model
  Para=Para_SIS(1,.2);     
  M<-Para[[1]];
  
#input the initial condition  
  x0=matrix(2,1,N); 
  
  
#simulation terminator 
  maxNumevent=35000;Runtime=30;

  
#simulating one realization of the epedimic process
  lst<-GEMF_SIM(Para,Net,x0,maxNumevent,Runtime,N);
    
  ts<-lst[[1]];
  n_index<-lst[[2]];
  i_index<-lst[[3]];
  j_index<-lst[[4]];
  Tf<-lst[[5]];
  lasteventnumber<-lst[[6]];

  
#calculating population of each comportmant through time
  lst2<-Post_Population(x0,M,N,ts,i_index,j_index,lasteventnumber);
  T<-lst2[[1]];
  StateCount<-lst2[[2]];
  compartment=1;# choosing a compartmant to plot its population throught time
  comppopulation<-StateCount[compartment,];
  plot(T,comppopulation);


#calculating state of nodes through time
  timstp=0.5;
  lst3<-Post_NodesState(x0,M,N,ts,n_index,j_index,lasteventnumber,timstp,Runtime);
  Tr=lst3[[1]];
  nodStt=lst3[[2]];

  
#using packages to make an animation of the nodes through time. colors represent the node states
  library(igraph); 
  library(animation);
   File2="edge.txt" #reading the list of edges from file
   dat=scan(File2);
   adl=t(matrix(dat,2,length(dat)/2));
   g=graph.edgelist(adl,directed=FALSE);
   lay=layout.graphopt(g);
   col<-c(rgb(0,0,1),rgb(1,0,0));#choosing colors for the comportmants. fisrt color for first compartment and...
   numofimages<-length(Tr); #chooseing number of time point be included in the animation

   saveGIF(
    {for(i in 1:numofimages){
      V(g)$color=col[nodStt[i,]];
      plot(g, layout=lay, vertex.size=3, vertex.label=NA);
      }}
    ,interval=0.3, ani.width = 1500,ani.height = 1000,
    movie.name = "SISmovie.gif",img.name = "SIS",
    convert = "convert",cmd.fun = system)#animation parameters
  
  
  